package core;

import java.lang.String;

import samples.ClientErrorException;
import samples.ServerErrorException;

// TODO: Auto-generated Javadoc
/**
 * The Class SampleRunner identifies and runs a single sample..
 */
public class SampleRunner {

	@SuppressWarnings("rawtypes")
	Class[] classParm = null;
	Object[] objectParm = null;

	/** The Full name of class. */
	public String FullName;

	/**
	 * Instantiates a new sample runner.
	 * 
	 * @param description
	 *            the description
	 */
	public SampleRunner(String description) {
		try {
			FullName = description;
			System.out.println("FullName " + FullName);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Runs the sample class Execute method and write standard messages.
	 * 
	 * @throws Throwable
	 *             the exceptions
	 * @throws ClientErrorException
	 *             the client error exception
	 * @throws ServerErrorException
	 *             the server error exception
	 * @throws ClassNotFoundException
	 *             the class not found exception
	 */
	public void Run() throws Throwable, ClientErrorException,
			ServerErrorException, ClassNotFoundException {
		System.out.println("RUNNING: " + FullName + ":");
		long start = System.currentTimeMillis();

		ISample sample = (ISample) Class.forName(FullName).newInstance();
		sample.Execute();

		long elapsedTimeMillis = System.currentTimeMillis() - start;
		float elapsedTimeSec = elapsedTimeMillis / 1000F;

		System.out.println("(Elapsed time: " + elapsedTimeSec + " seconds}");
		System.out.println("");
	}
}
