package samples;

import com.reuters.datascopeselect.extractionservice.v1.ClientError;
import com.reuters.datascopeselect.extractionservice.v1.ArrayOfString;

;

// TODO: Auto-generated Javadoc
/**
 * The Class ClientErrorException represents a client error.
 */
public class ClientErrorException extends Exception {

	private static final long serialVersionUID = 1L;
	private ClientError _clientError;

	/**
	 * Instantiates a new client error exception.
	 * 
	 * @param message
	 *            the message
	 * @param clientError
	 *            the client error
	 */
	public ClientErrorException(String message, ClientError clientError) {
		super(message);
		_clientError = clientError;
	}

	/**
	 * Gets the client error.
	 * 
	 * @return the client error
	 */
	public String getClientError() {
		return _clientError.getErrorCode();
	}

	/**
	 * Gets the client error message.
	 * 
	 * @return the client error message
	 */
	public ArrayOfString getClientErrorMessage() {
		return _clientError.getMessages();
	}
}
