package samples;

import samples.InvalidOutputFieldsException;
import com.reuters.datascopeselect.extractionservice.v1.*;

// TODO: Auto-generated Javadoc
/**
 * The Class ExtractionUtility contains utility methods used by samples to help
 * perform extractions against the API.
 */
public class ExtractionUtility {

	/**
	 * Ensure output fields are valid
	 * 
	 * @param extractionResponse
	 *            the extraction response
	 * @throws InvalidOutputFieldsException
	 *             the invalid output fields exception
	 * @throws Exception
	 *             the exception
	 */
	public static void EnsureOutputFields(ExtractionResponse extractionResponse)
			throws InvalidOutputFieldsException, Exception {
		ExtractionColumn CheckOutputField;
		ArrayOfString invalidOutputField = new ArrayOfString();
		for (int j = 0; j < extractionResponse.getColumns()
				.getExtractionColumn().size(); j++) {
			CheckOutputField = extractionResponse.getColumns()
					.getExtractionColumn().get(j);

			if (CheckOutputField.isFromInvalidOutputField() != null) {
				invalidOutputField.getString().add(CheckOutputField.getName());
			}
		}
		if (invalidOutputField.getString().size() > 0) {
			throw new InvalidOutputFieldsException(
					"There were one or more output fields requested in the extraction that were not supported.",
					invalidOutputField);
		}
	}

	/**
	 * Change data type.
	 * 
	 * @param arraySearchInstrument
	 *            the array search instrument
	 * @return the array of validated instrument
	 */
	public static ArrayOfValidatedInstrument ChangeDataType(
			ArrayOfValidatedSearchInstrument arraySearchInstrument) {
		ArrayOfValidatedInstrument arrayValidated = new ArrayOfValidatedInstrument();
		for (int n = 0; n < arraySearchInstrument
				.getValidatedSearchInstrument().size(); n++) {
			ValidatedInstrument newvalidated = new ValidatedInstrument();
			newvalidated.setAssetId(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getAssetId());
			newvalidated.setFileCode(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getFileCode());
			newvalidated.setIdentifierType(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getIdentifierType());
			newvalidated
					.setIdentifierValue(arraySearchInstrument
							.getValidatedSearchInstrument().get(n)
							.getIdentifierValue());
			newvalidated.setObjectType(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getObjectType());
			newvalidated.setQuoteId(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getQuoteId());
			newvalidated.setRic(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getRic());
			newvalidated.setSegment(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getSegment());
			newvalidated.setSource(arraySearchInstrument
					.getValidatedSearchInstrument().get(n).getSource());
			arrayValidated.getValidatedInstrument().add(newvalidated);
		}
		return arrayValidated;
	}
}
