package samples;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.List;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;

@SuppressWarnings("rawtypes")
public class JavaUtility {
	private static DatatypeFactory df = null;
	static {
		try {
			df = DatatypeFactory.newInstance();
		} catch (DatatypeConfigurationException dce) {
			throw new IllegalStateException(
					"Exception while obtaining DatatypeFactory instance", dce);
		}
	}

	public static XMLGregorianCalendar asXMLGregorianCalendar(
			java.util.Date date) {
		if (date == null) {
			return null;
		} else {
			GregorianCalendar gc = new GregorianCalendar();
			gc.setTimeInMillis(date.getTime());
			return df.newXMLGregorianCalendar(gc);
		}
	}

	public static java.util.Date asDate(XMLGregorianCalendar xgc) {
		if (xgc == null) {
			return null;
		} else {
			return xgc.toGregorianCalendar().getTime();
		}
	}

	public static java.util.Date dateadd(String calendarflag, int delta) {
		Calendar calendar = new GregorianCalendar();

		// calendarflag is either DAY, MONTH or YEAR to indicate which target
		// arithmetric
		if (calendarflag.toUpperCase().equals("DAY")) {
			calendar.add(Calendar.DAY_OF_MONTH, delta);
		} else if (calendarflag.toUpperCase().equals("MONTH")) {
			calendar.add(Calendar.MONTH, delta);
		} else if (calendarflag.toUpperCase().equals("YEAR")) {
			calendar.add(Calendar.YEAR, delta);
		} else {

		}
		Date newdate = calendar.getTime();
		return newdate;
	}

	public static GregorianCalendar dateset(GregorianCalendar targetdate,
			String calendarflag, int datevalue) {
		// calendarflag is either DAY, MONTH or YEAR to indicate which target
		// arithmetric
		if (calendarflag.toUpperCase().equals("DAY")) {
			targetdate.set(Calendar.DAY_OF_MONTH, datevalue);
		} else if (calendarflag.toUpperCase().equals("MONTH")) {
			targetdate.set(Calendar.MONTH, datevalue);
		} else if (calendarflag.toUpperCase().equals("YEAR")) {
			targetdate.set(Calendar.YEAR, datevalue);
		} else {
		}
		return targetdate;
	}

	public static Date changedatetype(GregorianCalendar targetdate) {
		Date newdate = targetdate.getTime();
		return newdate;
	}

	public static String printCalendar(Calendar calendar) {
		// define output format and print
		SimpleDateFormat sdf = new SimpleDateFormat("d MMM yyyy");
		String date = sdf.format(calendar.getTime());
		return date;
	}

	public static Class[] getClasses(String packageName)
			throws ClassNotFoundException, IOException {
		ClassLoader classLoader = Thread.currentThread()
				.getContextClassLoader();
		assert classLoader != null;
		String path = packageName.replace('.', '/');
		Enumeration<URL> resources = classLoader.getResources(path);
		List<File> dirs = new ArrayList<File>();
		while (resources.hasMoreElements()) {
			URL resource = resources.nextElement();
			dirs.add(new File(resource.getFile()));
		}
		ArrayList<Class> classes = new ArrayList<Class>();
		for (File directory : dirs) {
			classes.addAll(findClasses(directory, packageName));
		}
		return classes.toArray(new Class[classes.size()]);
	}

	public static List<Class> findClasses(File directory, String packageName)
			throws ClassNotFoundException {

		List<Class> classes = new ArrayList<Class>();
		if (!directory.exists()) {
			return classes;
		}
		File[] files = directory.listFiles();
		for (File file : files) {
			if (file.isDirectory()) {
				assert !file.getName().contains(".");
				classes.addAll(findClasses(file,
						packageName + "." + file.getName()));
			} else if (file.getName().endsWith(".class")) {
				classes.add(Class.forName(packageName
						+ '.'
						+ file.getName().substring(0,
								file.getName().length() - 6)));
			}
		}
		return classes;
	}

}
