package samples;

import com.reuters.datascopeselect.extractionservice.v1.ServerError;

// TODO: Auto-generated Javadoc
/**
 * The Class ServerErrorException that is thrown by the method when the SOAP
 * fault represents a server error.
 */
public class ServerErrorException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/** The _server error. */
	private ServerError _serverError;

	/**
	 * Instantiates a new server error exception.
	 * 
	 * @param message
	 *            the message
	 * @param serverError
	 *            the server error
	 */
	public ServerErrorException(String message, ServerError serverError) {
		super(message);
		_serverError = serverError;
	}

	/**
	 * Gets the error detail.
	 * 
	 * @return the error detail
	 */
	public String getErrorDetail() {
		return _serverError.getErrorDetail();
	}

	/**
	 * Gets the error instance id.
	 * 
	 * @return the error instance id
	 */
	public String getErrorInstanceId() {
		return _serverError.getErrorInstanceId();
	}

	/**
	 * Gets the host.
	 * 
	 * @return the host
	 */
	public String getHost() {
		return _serverError.getHost();
	}
}
