package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;

import com.reuters.datascopeselect.extractionservice.v1.*;
import core.ISample;

public class GetEstimateTypesSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();
		System.out.println("Invoking discoverability method...");
		ArrayOfEstimateTypeInfo response = new ArrayOfEstimateTypeInfo();
		try {
			response = proxy.getEstimateTypes(hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		for (int i = 0; i < response.getEstimateTypeInfo().size(); i++) {
			System.out.print(" "
					+ response.getEstimateTypeInfo().get(i).getValue()
							.toString() + ": "
					+ response.getEstimateTypeInfo().get(i).getDescription()
					+ " Extraction Types: ");
			for (int j = 0; j < response.getEstimateTypeInfo().get(i)
					.getExtractionTypes().getString().size(); j++) {
				System.out.print(response.getEstimateTypeInfo().get(i)
						.getExtractionTypes().getString().get(j)
						+ ", ");
			}
			System.out.println("");
		}
	}
}
