package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;

import com.reuters.datascopeselect.extractionservice.v1.*;
import core.ISample;

public class GetInstrumentExtractionTypesSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();
		System.out.println("Invoking discoverability method...");

		ArrayOfInstrumentExtractionTypeInfo response = new ArrayOfInstrumentExtractionTypeInfo();
		try {
			response = proxy.getInstrumentExtractionTypes(hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		for (int i = 0; i < response.getInstrumentExtractionTypeInfo().size(); i++) {
			System.out.println(" "
					+ response.getInstrumentExtractionTypeInfo().get(i)
							.getValue()
					+ " = "
					+ response.getInstrumentExtractionTypeInfo().get(i)
							.getDescription());
			System.out.println("- Asset Types =");
			for (int j = 0; j < response.getInstrumentExtractionTypeInfo()
					.get(i).getAssetTypes().getValueInfo().size(); j++) {
				System.out.println("  "
						+ response.getInstrumentExtractionTypeInfo().get(i)
								.getAssetTypes().getValueInfo().get(j)
								.getValue()
						+ ": "
						+ response.getInstrumentExtractionTypeInfo().get(i)
								.getAssetTypes().getValueInfo().get(j)
								.getDescription());
			}
			System.out.println("- MaximumInstrumentAllowed = "
					+ response.getInstrumentExtractionTypeInfo().get(i)
							.getMaximumInstrumentsAllowed());
			System.out.println("- TimePeriodForLimits = "
					+ response.getInstrumentExtractionTypeInfo().get(i)
							.getTimePeriodForLimits());
			System.out.println("- MaximumExtractionsAllowedPerTimePeriod = "
					+ response.getInstrumentExtractionTypeInfo().get(i)
							.getMaximumExtractionsAllowedPerTimePeriod());
			System.out.println("- MaximumInstrumentsAllowedPerTimePeriod = "
					+ response.getInstrumentExtractionTypeInfo().get(i)
							.getMaximumInstrumentsAllowedPerTimePeriod());
		}
	}
}
