package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;

import com.reuters.datascopeselect.extractionservice.v1.*;
import core.ISample;

public class GetInstrumentSearchTypesSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();
		System.out.println("Invoking discoverability method...");

		ArrayOfInstrumentSearchTypeInfo response = new ArrayOfInstrumentSearchTypeInfo();
		try {
			response = proxy.getInstrumentSearchTypes(hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		for (int i = 0; i < response.getInstrumentSearchTypeInfo().size(); i++) {
			System.out.println(" "
					+ response.getInstrumentSearchTypeInfo().get(i).getType()
					+ " - Supported Identifier Types ");
			for (int j = 0; j < response.getInstrumentSearchTypeInfo().get(i)
					.getSupportedIdentifierTypes().getValueInfo().size(); j++) {
				System.out.println("    "
						+ response.getInstrumentSearchTypeInfo().get(i)
								.getSupportedIdentifierTypes().getValueInfo()
								.get(j).getValue()
						+ " / "
						+ response.getInstrumentSearchTypeInfo().get(i)
								.getSupportedIdentifierTypes().getValueInfo()
								.get(j).getDescription());
			}
		}
	}
}
