package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;

import com.reuters.datascopeselect.extractionservice.v1.*;
import core.ISample;

public class GetLegalEntityExtractionTypesSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();
		System.out.println("Invoking discoverability method...");

		ArrayOfLegalEntityExtractionTypeInfo response = new ArrayOfLegalEntityExtractionTypeInfo();
		try {
			response = proxy.getLegalEntityExtractionTypes(hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		for (int i = 0; i < response.getLegalEntityExtractionTypeInfo().size(); i++) {
			System.out.println(" "
					+ response.getLegalEntityExtractionTypeInfo().get(i)
							.getValue()
					+ ": "
					+ response.getLegalEntityExtractionTypeInfo().get(i)
							.getDescription());
			System.out.println("  - Maximum Counterparties Allowed = "
					+ response.getLegalEntityExtractionTypeInfo().get(i)
							.getMaximumLegalEntitiesAllowed());
			System.out.println("  - Time Period for Limits = "
					+ response.getLegalEntityExtractionTypeInfo().get(i)
							.getTimePeriodForLimits());
			System.out
					.println("  - Maximum Counterparties Allowed per Time Period = "
							+ response
									.getLegalEntityExtractionTypeInfo()
									.get(i)
									.getMaximumLegalEntitiesAllowedPerTimePeriod());
			System.out
					.println("  - Maximum Extractions Allowed per Time Period = "
							+ response
									.getLegalEntityExtractionTypeInfo()
									.get(i)
									.getMaximumExtractionsAllowedPerTimePeriod());
		}
	}
}
