package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;

import com.reuters.datascopeselect.extractionservice.v1.*;
import core.ISample;

public class GetMbsAgencyTypesSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();
		ExtractionService_Service service = new ExtractionService_Service();
		ExtractionService proxy = service.getExtractionService();
		System.out.println("Invoking discoverability method...");

		ArrayOfValueInfo response = new ArrayOfValueInfo();
		try {
			response = proxy.getMbsAgencyTypes(hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		for (int i = 0; i < response.getValueInfo().size(); i++) {
			System.out.println(" " + response.getValueInfo().get(i).getValue()
					+ ": " + response.getValueInfo().get(i).getDescription());
		}
	}
}
