package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import com.reuters.datascopeselect.extractionservice.v1.ArrayOfValueInfo;
import com.reuters.datascopeselect.extractionservice.v1.CredentialsHeader;
import com.reuters.datascopeselect.extractionservice.v1.OperationInfoHeader;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;
import core.ISample;

public class GetNewsAnalyticsNoveltyOperatorsSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();

		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();

		System.out.println("Invoking discoverability method...");

		ArrayOfValueInfo response = new ArrayOfValueInfo();
		try {
			response = proxy.getNewsAnalyticsNoveltyOperators(hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		for (int i = 0; i < response.getValueInfo().size(); i++) {
			System.out.println(" " + response.getValueInfo().get(i).getValue()
					+ ": " + response.getValueInfo().get(i).getDescription());
		}
	}
}
