package samples.discoverability;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;

import com.reuters.datascopeselect.extractionservice.v1.*;

import core.ISample;

public class GetVersionSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();

		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();
		System.out.println("Invoking discoverability method...");
		VersionInfo response = new VersionInfo();
		try {
			response = proxy.getVersion(null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}
		System.out.println("DSS Version = " + response.getDssVersion());
		System.out.println("API Version = " + response.getApiVersion());
	}
}
