package samples.search.legalentity;

import javax.xml.ws.Holder;
import javax.xml.ws.soap.SOAPFaultException;

import com.reuters.datascopeselect.extractionservice.v1.*;

import samples.ApiUtility;
import samples.ClientErrorException;
import samples.ServerErrorException;
import core.ISample;

public class AllSample implements ISample {

	public void Execute() throws ClientErrorException, ServerErrorException,
			Exception {
		CredentialsHeader credentials = ApiUtility.CreateCredentials();
		Holder<CredentialsHeader> hch = ApiUtility.createhch(credentials);
		Holder<OperationInfoHeader> hoih = ApiUtility.createhoih();

		com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service service = new com.reuters.datascopeselect.extractionservice.v1.ExtractionService_Service();
		com.reuters.datascopeselect.extractionservice.v1.ExtractionService proxy = service
				.getExtractionService();

		String identifierType = "RCP";
		String searchValue = "30001228*";

		System.out.println("Searching for all legal entities that:");
		System.out.println("- are " + identifierType
				+ " identifiers that begin with " + searchValue);
		LegalEntitySearchRequestAll request = new LegalEntitySearchRequestAll();
		request.setIdentifierType(identifierType);
		request.setIdentifierSearchValue(searchValue);

		LegalEntitySearchResponse response = new LegalEntitySearchResponse();

		try {
			response = proxy.searchLegalEntities(request, hch, null, hoih);
		} catch (SOAPFaultException e) {
			throw ApiUtility.ConvertFaultException(e);
		}

		System.out.println(Integer.toString(response.getLegalEntities()
				.getValidatedLegalEntity().size())
				+ " LegalEntities found:");
		for (int i = 0; i < response.getLegalEntities()
				.getValidatedLegalEntity().size(); i++) {
			System.out.println(response.getLegalEntities()
					.getValidatedLegalEntity().get(i).getIdentifierType()
					+ ": "
					+ response.getLegalEntities().getValidatedLegalEntity()
							.get(i).getIdentifierValue());
			System.out.println("  - Entity ID = "
					+ response.getLegalEntities().getValidatedLegalEntity()
							.get(i).getEntityId());
			System.out.println("  - Org ID = "
					+ response.getLegalEntities().getValidatedLegalEntity()
							.get(i).getOrgId());
			System.out.println("  - Description = "
					+ response.getLegalEntities().getValidatedLegalEntity()
							.get(i).getDescription());
		}
	}
}
